<?php


namespace Teknisa\PLA\Modules\Parametros\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\GER\Services\CrudService;
use Doctrine\DBAL\Connection;

class Pla08800HistoricoDaUnidadeService extends \Teknisa\GER\Controllers\TeknisaCrud{
    protected $connection;
    protected $crudservice;
    protected $parameterbag;
    
    public function __construct($crudservice, $parameterbag, $entityManager) {
        $this->crudService = $crudservice;
        $this->parameterbag  = $parameterbag;
        $this->entityManager = $entityManager;
        $this->connection    = $entityManager->getConnection();
    }
    
    public function verifyParNegocio($row) {
        $sql = "SELECT NRPARCNEGOCIO FROM OPERADOR WHERE CDOPERADOR = :P_CDOPERADOR";
        $params = array(
            "P_CDOPERADOR" => $row['OPERADOR_LOGADO']    
        );
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        $result = $query->fetch();
        return $result;
    }

    public function verifyPerfAcess($nrparnegocio) {
        $sql = "SELECT NRPERFILACESSO FROM PERFACESSPARC WHERE NRPARCNEGOCIO = :P_NRPARCNEGOCIO";
        $params = array(
            "P_NRPARCNEGOCIO" => $nrparnegocio  
        );
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        return $result;
    }

    public function verifyAutPerfilAcesso() {
        $sql = "SELECT NRPERFILACESSO FROM AUTPERFILACESSO WHERE IDAUTPERFACESSO = 'MANHISTFILI'";
        $query = $this->connection->prepare($sql);
        $query->execute();
        $result = $query->fetch();
        return $result;
    }

    public function deleteHistorico($row) {
        $sql = "DELETE FROM OBSHISTFILIAL WHERE CDFILIAL = :P_CDFILIAL AND DTHISTFIL = TO_DATE(:P_DTHISTFIL, 'DD/MM/YYYY HH24:MI:SS') AND CDOPERADOR = :P_CDOPERADOR AND CDDESCOBSFILIAL = :P_CDDESCOBSFILIAL";
        $params = array(
            "P_CDFILIAL" => $row['CDFILIAL'],
            "P_DTHISTFIL" => $row['DTHISTFIL'],
            "P_CDOPERADOR" => $row['CDOPERADOR_ROW'],
            "P_CDDESCOBSFILIAL" => $row['CDDESCOBSFILIAL']
        );
        $query = $this->connection->prepare($sql);
        $query->execute($params);
    }
}