<?php
namespace Teknisa\PLA\Modules\Relatorio\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Pla01303EmissaoDasReceitas extends \Zeedhi\Framework\Controller\Report {
    
    protected $qr2Strategy;
    protected $birtStrategy;
    protected $util;
    protected $connection;
    protected $nrlista;
    protected $environment;
    protected $Pla01303EmissaoDasReceitasService;
    protected $fileServerFilesUrl;
    protected $listas;
    
    public function __construct($reportService, $qr2Strategy, $birtStrategy, \PLA\Util\Util $util, $entityManager, $environment, $Pla01303EmissaoDasReceitasService, $fileServerFilesUrl, $listas) {

        $this->qr2Strategy  = $qr2Strategy;
        $this->birtStrategy = $birtStrategy;
        $this->util = $util;
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment; 
        $this->Pla01303EmissaoDasReceitasService = $Pla01303EmissaoDasReceitasService;
        $this->fileServerFilesUrl = $fileServerFilesUrl;
        $this->listas = $listas;
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
    	'pla01300' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'CDFILIAL'   => 'P_CDFILIAL',
				'NIVEL'		 =>	'P_NIVEL',
				'MAXNIVEL'   =>	'P_MAXNIVEL',
				'CDFILIPROC' =>	'P_CDFILIPROC',
				'CDPRATOINI' =>	'P_CDPRATOINICIO',
				'PFINAL'  	 =>	'P_CDPRATOFINAL',
				'NRORG'      => 'P_NRORG' 
			),
		),
        'pla01306' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'CDFILIAL'   =>  'P_CDFILIAL',
                'CDPRATOINI' =>  'P_CDPRATOINIC',
                'PFINAL'     =>  'P_CDPRATOFINA',
                'NRORG'      =>  'P_NRORG',
                'CDPICTPRAT' =>  'P_CDPICTPRAT'
            ),
        ),
        'PLA01305' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'CDFILIAL'              => 'P_LISTAFILI',
                'PINICIAL'              => 'P_CDPRATOINIC',
                'PFINAL'                => 'P_CDPRATOFINA',
                'DTINICIAL'             => 'P_DTINICIAL',
                'DTFINAL'               => 'P_DTFINAL',
                'DATAINI'               => 'P_DATAINICIAL',
                'DATAFIN'               => 'P_DATAFINAL',
                'CDPRATOINI'            => 'P_PRATOINICIAL',
                'CDPRATOFIN'            => 'P_PRATOFINAL',
                'RECEITA_PADRAO'        => 'P_RECEITA_PADRAO',
                'PRATO_RECEITA_INATIVA' => 'P_PRATO_RECEITA_INATIVA',
                'NRORG'                 => 'P_NRORG'
            ),
        ),
        'PLA01301' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'CDFILIAL'       =>  'P_CDFILIAL',
                'ORDENA'         =>  'P_ORDENA',
                'NIVEL'          =>  'P_NIVEL',
                'MAXNIVEL'       =>  'P_MAXNIVEL',
                'CB_PRODUTOS'    =>  'P_IDRECEITA',
                'CB_MODOPREPARO' =>  'P_IDPREPARO',
                'CB_FOTO'        =>  'P_IDFOTO',
                'CB_NUTRIENTES'  =>  'P_IDNUTRIENTE',
                'CDPRATOINI'     =>  'P_CDPRATOINIC',
                'PFINAL'         =>  'P_CDPRATOFINA',
                'IDORIGEM'       =>  'P_IDTIPORECE',
                'CDSERVFILI'     =>  'P_CDSERVFILI',
                'NRORG'          =>  'P_NRORG',
                'FILESERVERPATH' => 'P_FILESERVERPATH'
            ),
        ),
        'PLA01309' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'ORDENA'         =>  'P_ORDENA',
                'NIVEL'          =>  'P_NIVEL',
                'MAXNIVEL'       =>  'P_MAXNIVEL',
                'CB_PRODUTOS'    =>  'P_IDRECEITA',
                'CB_MODOPREPARO' =>  'P_IDPREPARO',
                'CB_FOTO'        =>  'P_IDFOTO',
                'CB_NUTRIENTES'  =>  'P_IDNUTRIENTE',
                'DTINICIAL'      =>  'P_DATAINICIAL',
                'DTFINAL'        =>  'P_DATAFINAL',
                'CDPRATOINI'     =>  'P_CDPRATOINIC',
                'PFINAL'         =>  'P_CDPRATOFINA',
                'NRORG'          =>  'P_NRORG',
                'FILESERVERPATH' => 'P_FILESERVERPATH',
                'NRLISTA'        => 'P_NRLISTA'
            ),
        ),
        'pla05000' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'IDORIGEM'     => 'P_IDTIPORECE',
                'CDFILIAL'     => 'P_CDFILIAL',
                'CDNUTRIENTE'  => 'P_CDNUTRIENTE',
                'CDFILAUXPRAT' => 'P_CDFILAUXPRAT',
                'CDSERVFILI'   => 'P_CDSERVFILI',
                'CDFILCENTPME' => 'P_CDFILCENTPME',
                'CDTIPOCARD'   => 'P_CDTIPOCARD',
                'NIVEL'        => 'P_NIVEL',
                'CDPRATOINI'   => 'P_CDPRATOINIC',
                'CDPRATOFIN'   => 'P_CDPRATOFINA',
                'ORDENA'       => 'P_ORDENA',
                'CDPICTPRAT'   => 'P_CDPICTPRAT',
                'NRORG'        => 'P_NRORG'
            ),
        ),
        'pla05500' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'IDORIGEM'     => 'P_IDTIPORECE',
                'CDFILIAL'     => 'P_CDFILIAL',
                'CDFILCENTPME' => 'P_CDFILCENTPME',
                'CDTIPOCARD'   => 'P_CDTIPOCARD',
                'CDARVPRODINI' => 'P_PRODUTOINI',
                'CDARVPRODFIN' => 'P_PRODUTOFIN',
                'CDPICTPROD'   => 'P_CDPICTPROD',
                'CDPICTPRAT'   => 'P_CDPICTPRAT',
                'NRLISTAFILI'  => 'P_LISTAFILI',
                'NRLISTASERV'  => 'P_LISTASERV',
                'NRORG'        => 'P_NRORG'
            )
        ),
        'pla05400' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'CDGRUPFILI'        => 'P_CDGRUPO', //CDGRUPFILI
                'CDFILIAL'          => 'P_CDFILIAL',
                'CDFILAUXPRAT'      => 'P_CDFILAUXPRAT',
                'CDPRATOINI'        => 'P_CDPRATINI',
                'CDPRATOFIN'        => 'P_CDPRATFIN',
                'CDARVPRODINI'      => 'P_CDPRODINI',
                'CDARVPRODFIN'      => 'P_CDPRODFIN',
                'CDPICTPROD'        => 'P_CDPICTPROD',
                'IDTPREQPRODFILI'   => 'P_IDTPREQPRODFILI',
                'CDPICTPRAT'        => 'P_CDPICTPRAT',
                'NRORG'             => 'P_NRORG'
            )
        ),
        'pla013B' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'IDORIGEM'     => 'P_IDTIPORECE',
                'CDFILIAL'     => 'P_CDFILIAL',
                'CDNUTRIENTE'  => 'P_CDNUTRIENTE',
                'CDSERVFILI'   => 'P_CDSERVFILI',
                'CDPRATOINI'   => 'P_CDPRATOINIC',
                'CDPRATOFIN'   => 'P_CDPRATOFINA',
                'NRORG'        => 'P_NRORG'
            )
        ),
        'pla0130B' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'IDORIGEM'     => 'P_IDTIPORECE',
                'CDFILIAL'     => 'P_CDFILIAL',
                'CDNUTRIENTE'  => 'P_CDNUTRIENTE',
                'CDSERVFILI'   => 'P_CDSERVFILI',
                'CDPRATOINI'   => 'P_CDPRATOINIC',
                'CDPRATOFIN'   => 'P_CDPRATOFINA',
                'NRORG'        => 'P_NRORG',
                'DSIMPNDPCAL'  => 'P_DSIMPNDPCAL',
                'IMPRIMIRNOMEFANTASIA' => 'P_IMPRIMIRNOMEFANTASIA'
            )
        ),
        'PLA01302' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'NRORG'        => 'P_NRORG',
                'CDFILIAL'     => 'P_CDFILIAL',
                'CDFILIPROC'   => 'P_CDFILIPROC',
                'CDPRATOINI'   => 'P_CDPRATOINIC',
                'CDPRATOFIN'   => 'P_CDPRATOFINA',
                'CDTIPOCUSTO'  => 'P_NRTIPOCUST',
                'NMTIPOCUSTO'  => 'P_NMTIPOCUST'
            )
        ),
        'PLA01303' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'NRORG'        => 'P_NRORG',
                'CDFILIAL'     => 'P_CDFILIAL',
                'CDFILIPROC'   => 'P_CDFILIPROC',
                'CDSERVFILI'   => 'P_CDSERVFILI',
                'CDPRATOINI'   => 'P_CDPRATOINIC',
                'CDPRATOFIN'   => 'P_CDPRATOFINA',
                'CDTIPOCUSTO'  => 'P_NRTIPOCUST',
                'NMTIPOCUSTO'  => 'P_NMTIPOCUST'
            )
        ),
        'PLA0130A' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'NRORG'        => 'P_NRORG',
                'CDFILIAL'     => 'CDFILIAL',
                'CDSERVFILI'   => 'CDSERVFILI',
                'CDPRATOINI'   => 'CDPRATOINIC',
                'CDPRATOFIN'   => 'CDPRATOFINA',
                'IDORIGEM'  => 'IDTIPORECE',
                'MAXNIVEL'  => 'CDNVPRATO'
            )
        )
	);
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $completaCom = 'Z';
        if($row['ORDENA'] == 0){
            $row['NIVEL'] = 10;
        }else{
            $row['NIVEL'] = intval($row['NIVEL'])*2;
        }
        $row['CDFILIAL']     = isset($row['CDFILIAL']) ? $row['CDFILIAL'] : $row['CDFILIPROC'];
        $row['TCDFILIAL']    = $row['CDFILIAL'];
        $row['TCDSERVFILI']  = $row['CDSERVFILI'];
        $row['CDARVPRODINI'] = isset($row['CDARVPRODINI']) ? $row['CDARVPRODINI'] : '';
        $row['CDARVPRODFIN'] = isset($row['CDARVPRODFIN']) ? str_pad($row['CDARVPRODFIN'], 10, $completaCom, STR_PAD_RIGHT) : '';
        $row['PINICIAL']     = isset($row['CDPRATOINI']) ? $row['CDPRATOINI'] : '';
        $row['PFINAL']       = isset($row['CDPRATOFIN']) ? str_pad($row['CDPRATOFIN'], 10, $completaCom, STR_PAD_RIGHT) : '';
        $row['CDPRODFIN']    = isset($row['CDPRODFIN']) ? str_pad($row['CDPRODFIN'], 10, $completaCom, STR_PAD_RIGHT) : '';
        $row['DATAINI']      = $row['DTINICIAL'];
        $row['DATAFIN']      = $row['DTFINAL'];
        $row['CDFILCENTPME'] = NULL; //Ainda não utilizado nessa rotina - somente merendas
        $row['CDTIPOCARD']   = NULL;
        $row['NRORG']        = $this->environment->getNrOrg();
        $row['CDGRUPFILI']   = isset($row['CDGRUPFILI']) ? $row['CDGRUPFILI'] : 'T';
        if(isset($row['TODOSNUTRIENTES']) && $row['TODOSNUTRIENTES'] == 'S'){
            $row['CDNUTRIENTE'] = 'T';
        } else if(isset($row['CDNUTRIENTE']) && is_array($row['CDNUTRIENTE'])){
            $row['CDNUTRIENTE'] = implode('_', $row['CDNUTRIENTE']);
        }
        if($row['REPORT_NAME'] === 'pla05400'){
            $row['CDFILIAL'] = isset($row['TODOSUNIDADES']) && $row['TODOSUNIDADES'] == 'S' ? 'T' : implode('_', $row['NMFILIALSELECTMULTIPLE']);
            $row['IDTPREQPRODFILI'] = '';
            if(isset($row['PRODUCAO']) && $row['PRODUCAO'] == 'S'){
                $row['IDTPREQPRODFILI'] .= 'P';
            } else {
                $row['IDTPREQPRODFILI'] .= 'X';
            }
            if(isset($row['DISTRIBUICAO']) && $row['DISTRIBUICAO'] == 'S'){
                $row['IDTPREQPRODFILI'] .= 'D';
            } else {
                $row['IDTPREQPRODFILI'] .= 'X';
            }
            if(isset($row['ENTREGA_DIRETA']) && $row['ENTREGA_DIRETA'] == 'S'){
                $row['IDTPREQPRODFILI'] .= 'E';
            } else {
                $row['IDTPREQPRODFILI'] .= 'X';
            }
        }
        
        if($row['REPORT_NAME'] === 'pla05500'){
            if($row['IDORIGEM_P'] === 'N'){
                $cdFiliServ = $this->getFiliServ($row);
                $this->nrlista = $this->util->insertLista($cdFiliServ);
                $row["NRLISTA"] = $this->nrlista;
            }
            if($row['IDORIGEM_L'] === 'S'){
                $row['NRLISTAFILI'] = $this->nrlista;
                $row['NRLISTASERV'] = NULL;
            } else if($row['IDORIGEM_S'] == 'S'){
                $row['NRLISTAFILI'] = NULL;
                $row['NRLISTASERV'] = $this->nrlista;
            } else if($row['IDORIGEM_P'] == 'S'){
                $row['NRLISTAFILI'] = NULL;
                $row['NRLISTASERV'] = NULL;
            }
        }
        $row['CDPRATOFIN'] = str_pad($row['CDPRATOFIN'], 10, "z", STR_PAD_RIGHT);
        $row['FILESERVERPATH'] = $this->fileServerFilesUrl;
        if($row['REPORT_NAME'] == 'PLA01309'){
            $filiais = isset($row['TODOSUNIDADES']) && $row['TODOSUNIDADES'] == 'S' ? 'T' : implode('_', $row['NMFILIALSELECTMULTIPLE']);
            $servicos = 'T'; 
            if(isset($row['TODOSSERVICOS']) && $row['TODOSSERVICOS'] != 'S'){
                if(isset($row['NMSERVICOSELECTMULTIPLE'])){
                    $servicos = array();
                    foreach($row['NMSERVICOSELECTMULTIPLE'] as $servico){
                        $servicos[] = ['CDFILIAL' => $servico['CDFILIAL'], 'CDSERVFILI' => $servico['CDSERVFILI']];
                    }    
                }    
            }
            $row['NRLISTA'] = $this->listas->retornaListaFilialServico(null, $filiais, 'T', $servicos, false, false, false);
        }
        // Pela estruturação do relatório, deve respeitar a passagem de parâmetros do tipo
        if ($row['REPORT_NAME'] == 'PLA0130A') {
            if ($row['IDORIGEM'] == 'P') {
                $row['CDFILIAL'] = null;
                $row['CDSERVFILI'] = null;
            } else if ($row['IDORIGEM'] == 'F' || $row['IDORIGEM'] == 'L') {
                $row['CDSERVFILI'] = null;
            }
        }
        
        $row['CDFILIPROC'] = $this->environment->getCdFilial();
    }
    
    public function getFiliServ($row){
        $cdgrupfili = isset($row['CDGRUPFILI']) && $row['CDGRUPFILI'] ? $row['CDGRUPFILI'] : 'T';
        if($row['IDORIGEM_L'] === 'S'){
            if($row['TODOSUNIDADES'] === 'S'){
                $params = array(
                    'CDOPERADOR' =>  $this->environment->getCdOperador(),
                    'CDGRUPFILI' =>  $cdgrupfili
                );
                
                $filiais = $this->Pla01303EmissaoDasReceitasService->returnFilial($params); 
                return $filiais;
            } else{
                $filiais = $row['NMFILIALSELECTMULTIPLE'];
                return $filiais;
            }
        } else if($row["IDORIGEM_S"] === 'S'){
            if($row['TODOSUNIDADES'] === 'S'){
                if($row['TODOSSERVICOS'] === 'S'){
                    $params = array(
                        'CDOPERADOR' => $this->environment->getCdOperador(),
                        'CDGRUPFILI' => $cdgrupfili,
                        'CDFILIAL' => 'T'
                    );
                    $cdFiliServ = $this->Pla01303EmissaoDasReceitasService->returnFiliServ($params); 
                    return $cdFiliServ;
                } else{
                    $servicos = $row['NMSERVICOSELECTMULTIPLE'];
                    $cdFiliServ = array();
                    foreach($servicos as $servico){
                        $cdFiliServ[] = $servico['CDFILIAL'].$servico['CDSERVFILI'];
                    }
                    return $cdFiliServ;
                }
            } else{
                if($row['TODOSSERVICOS'] === 'S'){
                    $rowFilial = implode("_", $row['NMFILIALSELECTMULTIPLE']);
                    $params = array(
                        'CDOPERADOR' => $this->environment->getCdOperador(),
                        'CDGRUPFILI' => $cdgrupfili,
                        'CDFILIAL' => $rowFilial
                    );
                    $cdFiliServ = $this->Pla01303EmissaoDasReceitasService->returnFiliServ($params);
                    return $cdFiliServ;
                } else{
                    $servicos = $row['NMSERVICOSELECTMULTIPLE'];
                    $cdFiliServ = array();
                    foreach($servicos as $servico){
                        $cdFiliServ[] = $servico['CDFILIAL'].$servico['CDSERVFILI'];
                    }
                    return $cdFiliServ;
                }
            }
        }
    }
}